#ifndef GSLDatei_H
#define GSLDatei_H

#include <Text.h>
#include <Array.h>
#include <Datei.h>
#include <Critical.h>
#include "Include/GSLDateiV.h"

using namespace Framework;

namespace GSL
{
	struct SoundKopf
	{
		Text name;
		char channels;
		unsigned int sampleRate = 0;
		__int64 datPos = 0;
		__int64 datEnd = 0;
		Text pfad;
	};

	class GSLDatei : public GSLDateiV
	{
	private:
		Array< SoundKopf >* sounds;
		Text* pfad;
		Critical cs;

	public:
		// Konstruktor
		GSLDatei();
		// Destruktor
		~GSLDatei();
		// Datei open
		void setDatei(Framework::Text* txt) override;
		void setDatei(const char* txt) override;
		bool leseDaten() override;
		int getSoundAnzahl() override;
		Text* getSoundName(int num) override;
		// Laden
		GSLSoundV* getSound(Framework::Text* name) override;
		GSLSoundV* getSound(const char* name) override;
		// Speichern
		bool speicherSound(GSLSoundV* zSound, Framework::Text* name) override;
		bool speicherSound(GSLSoundV* zSound, const char* name) override;
		// Lschen
		bool removeSound(Framework::Text* name) override;
		bool removeSound(const char* name) override;
	};
}

#endif